Please note: This project is no longer active. The website is kept online for historic purposes only.
If you´re looking for a Linux driver for your Atheros WLAN device, you should continue here .

Ticket #1903 (assigned defect)

Opened 11 years ago

Last modified 9 years ago

Channel switch on active interface in master mode causes hard lockup

Reported by: sjensne@versanet.de Assigned to: proski (accepted)
Priority: blocker Milestone: version 0.9.4.1
Component: madwifi: driver Version: v0.9.4
Keywords: master mode ap deadlock freeze channel Cc:
Patch is attached: 0 Pending: 0

Description

Hi,...

when running my "AR5413 802.11abg NIC (rev 01)" in Master Mode and doing something with iwconfig, e.g. "iwconfig ath0 channel 9" my Machine hard freezes requiring power cycle reboot. No error messages displayed and no logs written, just lock-up.

Steps taken:

$ wlanconfig wlan0 create wlandev wifi0 wlanmode ap

Result: wlan0 is created in Master mode

$ iwconfig wlan0

Result: shows normal information of wlan0 in master mode

$ iwconfig wlan0 channel 9

Result: dead lock.

Station mode (sta) on the same Maschine runs very nice without any problems.

$ uname -a

Linux localhost.localdomain 2.6.24.4-64.fc8 #1 SMP Sat Mar 29 09:54:46 EDT 2008 i686 athlon i386 GNU/Linux

Using madwifi from livna:

 kmod-madwifi-0.9.4-6.lvn8
 kmod-madwifi-2.6.24.4-64.fc8-0.9.4-6.lvn8
 madwifi-0.9.4-1.lvn8
 wireless-tools-29-0.2.pre22.fc8

$ lspci | grep Atheros

04:0a.0 Ethernet controller: Atheros Communications, Inc. AR5413 802.11abg NIC (rev 01)

Change History

(in reply to: ↑ description ) 04/22/08 17:26:06 changed by laurent.barbe-forums@laposte.net

Hello,

I've the same problem when running a

wlanconfig ath0 create wlandev wifi0 wlanmode ap

Then, my system freeze... and no log in /var/log/syslog

$ uname -a

Linux bureau 2.6.24-16-server #1 SMP Thu Apr 10 13:15:38 UTC 2008 x86_64 GNU/Linux

$ lspci | grep Atheros

01:06.0 Ethernet controller: Atheros Communications Inc. AR5212/AR5213 Multiprotocol MAC/baseband processor (rev 01)

$ modinfo ath_pci

filename:       /lib/modules/2.6.24-16-server/madwifi/ath_pci.ko
license:        Dual BSD/GPL
version:        0.9.4
description:    Support for Atheros 802.11 wireless LAN cards.
author:         Errno Consulting, Sam Leffler
...

04/25/08 20:29:11 changed by monster7978

Look here in ticket #1881 its the same...

monster7978

05/01/08 01:19:11 changed by m@tthew.ca

I think I have a similar problem. I'm running a fresh install of Ubuntu 8.04 Hardy Heron on an AMD64 box. I have un-installed network-manager to no avail. Here is the output of: uname -a

Linux mr-turk 2.6.24-16-generic #1 SMP Thu Apr 10 12:47:45 UTC 2008 x86_64 GNU/Linux

the output of: lspci | grep Atheros

04:08.0 Ethernet controller: Atheros Communications Inc. AR5212/AR5213 Multiprotocol MAC/baseband processor (rev 01)

and the output of: modinfo ath_pci

filename:       /lib/modules/2.6.24-16-generic/madwifi/ath_pci.ko
license:        Dual BSD/GPL
version:        0.9.4

I can run any of the following commands without a crash (not at the same time, or in this semi-meaningless sequence):

wlanconfig ath0 destroy
wlanconfig ath0 create wlandev wifi0
wlanconfig ath0 create wlandev wifi0 wlanmode sta

However, after destroying ath0, if I run either of these commands:

wlanconfig ath0 create wlandev wifi0 wlanmode master
wlanconfig ath0 create wlandev wifi0 wlanmode ap

then the system freezes about 2-4 seconds after hitting Enter. It becomes totally unresponsive to the keyboard (can't restart X with Ctrl-Alt-Backspace, or reboot with Ctrl-Alt-Del, or get to a text console via the F-keys, or reboot using any of the Alt-PrintScreen? keys). The only solution is a hard reset.

Upon rebooting, the following can be found in the /var/log/syslog:

Apr 30 17:58:59 mr-turk kernel: [  138.565313] sysctl table check failed: /net/ath0/debug  Sysctl already exists
Apr 30 17:58:59 mr-turk kernel: [  138.565324] Pid: 9660, comm: wlanconfig Tainted: P        2.6.24-16-generic #1
Apr 30 17:58:59 mr-turk kernel: [  138.565326] 
Apr 30 17:58:59 mr-turk kernel: [  138.565327] Call Trace:
Apr 30 17:58:59 mr-turk kernel: [  138.565358]  [set_fail+0x4d/0x70] set_fail+0x4d/0x70
Apr 30 17:58:59 mr-turk kernel: [  138.565367]  [sysctl_check_table+0x2c5/0x620] sysctl_check_table+0x2c5/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.565372]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.565388]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.565393]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.565409]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.565430]  [xfs:register_sysctl_table+0x60/0xe0] register_sysctl_table+0x60/0xc0
Apr 30 17:58:59 mr-turk kernel: [  138.565453]  [wlan:ieee80211_sysctl_vattach+0x1b1/0x310] :wlan:ieee80211_sysctl_vattach+0x1b1/0x310
Apr 30 17:58:59 mr-turk kernel: [  138.565471]  [ath_pci:ieee80211_vap_setup+0x288/0x380] :wlan:ieee80211_vap_setup+0x288/0x380
Apr 30 17:58:59 mr-turk kernel: [  138.565498]  [ath_pci:ath_vap_create+0x139/0x710] :ath_pci:ath_vap_create+0x139/0x710
Apr 30 17:58:59 mr-turk kernel: [  138.565530]  [wlan:ieee80211_ioctl_create_vap+0xc4/0x100] :wlan:ieee80211_ioctl_create_vap+0xc4/0x100
Apr 30 17:58:59 mr-turk kernel: [  138.565540]  [__do_fault+0x1f5/0x430] __do_fault+0x1f5/0x430
Apr 30 17:58:59 mr-turk kernel: [  138.565564]  [ath_pci:ath_ioctl+0xc1/0x2e0] :ath_pci:ath_ioctl+0xc1/0x2e0
Apr 30 17:58:59 mr-turk kernel: [  138.565573]  [ipv6:__dev_get_by_name+0x8f/0x360] __dev_get_by_name+0x8f/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.565589]  [dev_ioctl+0x3f2/0x590] dev_ioctl+0x3f2/0x590
Apr 30 17:58:59 mr-turk kernel: [  138.565605]  [xt_hashlimit:kmem_cache_alloc+0x67/0xa0] kmem_cache_alloc+0x67/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.565617]  [sk_prot_alloc+0x51/0xe0] sk_prot_alloc+0x51/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.565637]  [sock_ioctl+0xed/0x260] sock_ioctl+0xed/0x260
Apr 30 17:58:59 mr-turk kernel: [  138.565649]  [do_ioctl+0x2f/0xa0] do_ioctl+0x2f/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.565657]  [vfs_ioctl+0x220/0x2c0] vfs_ioctl+0x220/0x2c0
Apr 30 17:58:59 mr-turk kernel: [  138.565662]  [xfs:fd_install+0x25/0x210] fd_install+0x25/0x60
Apr 30 17:58:59 mr-turk kernel: [  138.565674]  [sys_ioctl+0x91/0xb0] sys_ioctl+0x91/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.565689]  [system_call+0x7e/0x83] system_call+0x7e/0x83
Apr 30 17:58:59 mr-turk kernel: [  138.565719] 
Apr 30 17:58:59 mr-turk kernel: [  138.565725] sysctl table check failed: /net/ath0/dev_type  Sysctl already exists
Apr 30 17:58:59 mr-turk kernel: [  138.565729] Pid: 9660, comm: wlanconfig Tainted: P        2.6.24-16-generic #1
Apr 30 17:58:59 mr-turk kernel: [  138.565730] 
Apr 30 17:58:59 mr-turk kernel: [  138.565731] Call Trace:
Apr 30 17:58:59 mr-turk kernel: [  138.565738]  [set_fail+0x4d/0x70] set_fail+0x4d/0x70
Apr 30 17:58:59 mr-turk kernel: [  138.565746]  [sysctl_check_table+0x2c5/0x620] sysctl_check_table+0x2c5/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.565751]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.565767]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.565772]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.565788]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.565808]  [xfs:register_sysctl_table+0x60/0xe0] register_sysctl_table+0x60/0xc0
Apr 30 17:58:59 mr-turk kernel: [  138.565825]  [wlan:ieee80211_sysctl_vattach+0x1b1/0x310] :wlan:ieee80211_sysctl_vattach+0x1b1/0x310
Apr 30 17:58:59 mr-turk kernel: [  138.565843]  [ath_pci:ieee80211_vap_setup+0x288/0x380] :wlan:ieee80211_vap_setup+0x288/0x380
Apr 30 17:58:59 mr-turk kernel: [  138.565868]  [ath_pci:ath_vap_create+0x139/0x710] :ath_pci:ath_vap_create+0x139/0x710
Apr 30 17:58:59 mr-turk kernel: [  138.565900]  [wlan:ieee80211_ioctl_create_vap+0xc4/0x100] :wlan:ieee80211_ioctl_create_vap+0xc4/0x100
Apr 30 17:58:59 mr-turk kernel: [  138.565909]  [__do_fault+0x1f5/0x430] __do_fault+0x1f5/0x430
Apr 30 17:58:59 mr-turk kernel: [  138.565933]  [ath_pci:ath_ioctl+0xc1/0x2e0] :ath_pci:ath_ioctl+0xc1/0x2e0
Apr 30 17:58:59 mr-turk kernel: [  138.565941]  [ipv6:__dev_get_by_name+0x8f/0x360] __dev_get_by_name+0x8f/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.565957]  [dev_ioctl+0x3f2/0x590] dev_ioctl+0x3f2/0x590
Apr 30 17:58:59 mr-turk kernel: [  138.565973]  [xt_hashlimit:kmem_cache_alloc+0x67/0xa0] kmem_cache_alloc+0x67/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.565985]  [sk_prot_alloc+0x51/0xe0] sk_prot_alloc+0x51/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.566004]  [sock_ioctl+0xed/0x260] sock_ioctl+0xed/0x260
Apr 30 17:58:59 mr-turk kernel: [  138.566016]  [do_ioctl+0x2f/0xa0] do_ioctl+0x2f/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.566024]  [vfs_ioctl+0x220/0x2c0] vfs_ioctl+0x220/0x2c0
Apr 30 17:58:59 mr-turk kernel: [  138.566028]  [xfs:fd_install+0x25/0x210] fd_install+0x25/0x60
Apr 30 17:58:59 mr-turk kernel: [  138.566040]  [sys_ioctl+0x91/0xb0] sys_ioctl+0x91/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.566056]  [system_call+0x7e/0x83] system_call+0x7e/0x83
Apr 30 17:58:59 mr-turk kernel: [  138.566085] 
Apr 30 17:58:59 mr-turk kernel: [  138.566091] sysctl table check failed: /net/ath0/monitor_nods_only  Sysctl already exists
Apr 30 17:58:59 mr-turk kernel: [  138.566095] Pid: 9660, comm: wlanconfig Tainted: P        2.6.24-16-generic #1
Apr 30 17:58:59 mr-turk kernel: [  138.566096] 
Apr 30 17:58:59 mr-turk kernel: [  138.566097] Call Trace:
Apr 30 17:58:59 mr-turk kernel: [  138.566104]  [set_fail+0x4d/0x70] set_fail+0x4d/0x70
Apr 30 17:58:59 mr-turk kernel: [  138.566112]  [sysctl_check_table+0x2c5/0x620] sysctl_check_table+0x2c5/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.566117]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.566133]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.566138]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.566154]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.566175]  [xfs:register_sysctl_table+0x60/0xe0] register_sysctl_table+0x60/0xc0
Apr 30 17:58:59 mr-turk kernel: [  138.566192]  [wlan:ieee80211_sysctl_vattach+0x1b1/0x310] :wlan:ieee80211_sysctl_vattach+0x1b1/0x310
Apr 30 17:58:59 mr-turk kernel: [  138.566210]  [ath_pci:ieee80211_vap_setup+0x288/0x380] :wlan:ieee80211_vap_setup+0x288/0x380
Apr 30 17:58:59 mr-turk kernel: [  138.566235]  [ath_pci:ath_vap_create+0x139/0x710] :ath_pci:ath_vap_create+0x139/0x710
Apr 30 17:58:59 mr-turk kernel: [  138.566268]  [wlan:ieee80211_ioctl_create_vap+0xc4/0x100] :wlan:ieee80211_ioctl_create_vap+0xc4/0x100
Apr 30 17:58:59 mr-turk kernel: [  138.566277]  [__do_fault+0x1f5/0x430] __do_fault+0x1f5/0x430
Apr 30 17:58:59 mr-turk kernel: [  138.566302]  [ath_pci:ath_ioctl+0xc1/0x2e0] :ath_pci:ath_ioctl+0xc1/0x2e0
Apr 30 17:58:59 mr-turk kernel: [  138.566310]  [ipv6:__dev_get_by_name+0x8f/0x360] __dev_get_by_name+0x8f/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.566326]  [dev_ioctl+0x3f2/0x590] dev_ioctl+0x3f2/0x590
Apr 30 17:58:59 mr-turk kernel: [  138.566341]  [xt_hashlimit:kmem_cache_alloc+0x67/0xa0] kmem_cache_alloc+0x67/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.566354]  [sk_prot_alloc+0x51/0xe0] sk_prot_alloc+0x51/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.566373]  [sock_ioctl+0xed/0x260] sock_ioctl+0xed/0x260
Apr 30 17:58:59 mr-turk kernel: [  138.566385]  [do_ioctl+0x2f/0xa0] do_ioctl+0x2f/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.566393]  [vfs_ioctl+0x220/0x2c0] vfs_ioctl+0x220/0x2c0
Apr 30 17:58:59 mr-turk kernel: [  138.566397]  [xfs:fd_install+0x25/0x210] fd_install+0x25/0x60
Apr 30 17:58:59 mr-turk kernel: [  138.566409]  [sys_ioctl+0x91/0xb0] sys_ioctl+0x91/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.566424]  [system_call+0x7e/0x83] system_call+0x7e/0x83
Apr 30 17:58:59 mr-turk kernel: [  138.566454] 
Apr 30 17:58:59 mr-turk kernel: [  138.566460] sysctl table check failed: /net/ath0/monitor_txf_len  Sysctl already exists
Apr 30 17:58:59 mr-turk kernel: [  138.566463] Pid: 9660, comm: wlanconfig Tainted: P        2.6.24-16-generic #1
Apr 30 17:58:59 mr-turk kernel: [  138.566464] 
Apr 30 17:58:59 mr-turk kernel: [  138.566465] Call Trace:
Apr 30 17:58:59 mr-turk kernel: [  138.566472]  [set_fail+0x4d/0x70] set_fail+0x4d/0x70
Apr 30 17:58:59 mr-turk kernel: [  138.566480]  [sysctl_check_table+0x2c5/0x620] sysctl_check_table+0x2c5/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.566485]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.566501]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.566506]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.566522]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.566541]  [xfs:register_sysctl_table+0x60/0xe0] register_sysctl_table+0x60/0xc0
Apr 30 17:58:59 mr-turk kernel: [  138.566559]  [wlan:ieee80211_sysctl_vattach+0x1b1/0x310] :wlan:ieee80211_sysctl_vattach+0x1b1/0x310
Apr 30 17:58:59 mr-turk kernel: [  138.566576]  [ath_pci:ieee80211_vap_setup+0x288/0x380] :wlan:ieee80211_vap_setup+0x288/0x380
Apr 30 17:58:59 mr-turk kernel: [  138.566601]  [ath_pci:ath_vap_create+0x139/0x710] :ath_pci:ath_vap_create+0x139/0x710
Apr 30 17:58:59 mr-turk kernel: [  138.566633]  [wlan:ieee80211_ioctl_create_vap+0xc4/0x100] :wlan:ieee80211_ioctl_create_vap+0xc4/0x100
Apr 30 17:58:59 mr-turk kernel: [  138.566642]  [__do_fault+0x1f5/0x430] __do_fault+0x1f5/0x430
Apr 30 17:58:59 mr-turk kernel: [  138.566667]  [ath_pci:ath_ioctl+0xc1/0x2e0] :ath_pci:ath_ioctl+0xc1/0x2e0
Apr 30 17:58:59 mr-turk kernel: [  138.566675]  [ipv6:__dev_get_by_name+0x8f/0x360] __dev_get_by_name+0x8f/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.566691]  [dev_ioctl+0x3f2/0x590] dev_ioctl+0x3f2/0x590
Apr 30 17:58:59 mr-turk kernel: [  138.566707]  [xt_hashlimit:kmem_cache_alloc+0x67/0xa0] kmem_cache_alloc+0x67/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.566719]  [sk_prot_alloc+0x51/0xe0] sk_prot_alloc+0x51/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.566738]  [sock_ioctl+0xed/0x260] sock_ioctl+0xed/0x260
Apr 30 17:58:59 mr-turk kernel: [  138.566750]  [do_ioctl+0x2f/0xa0] do_ioctl+0x2f/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.566758]  [vfs_ioctl+0x220/0x2c0] vfs_ioctl+0x220/0x2c0
Apr 30 17:58:59 mr-turk kernel: [  138.566762]  [xfs:fd_install+0x25/0x210] fd_install+0x25/0x60
Apr 30 17:58:59 mr-turk kernel: [  138.566774]  [sys_ioctl+0x91/0xb0] sys_ioctl+0x91/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.566790]  [system_call+0x7e/0x83] system_call+0x7e/0x83
Apr 30 17:58:59 mr-turk kernel: [  138.566830] 
Apr 30 17:58:59 mr-turk kernel: [  138.566836] sysctl table check failed: /net/ath0/monitor_phy_errors  Sysctl already exists
Apr 30 17:58:59 mr-turk kernel: [  138.566840] Pid: 9660, comm: wlanconfig Tainted: P        2.6.24-16-generic #1
Apr 30 17:58:59 mr-turk kernel: [  138.566841] 
Apr 30 17:58:59 mr-turk kernel: [  138.566842] Call Trace:
Apr 30 17:58:59 mr-turk kernel: [  138.566849]  [set_fail+0x4d/0x70] set_fail+0x4d/0x70
Apr 30 17:58:59 mr-turk kernel: [  138.566857]  [sysctl_check_table+0x2c5/0x620] sysctl_check_table+0x2c5/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.566862]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.566878]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.566883]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.566899]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.566919]  [xfs:register_sysctl_table+0x60/0xe0] register_sysctl_table+0x60/0xc0
Apr 30 17:58:59 mr-turk kernel: [  138.566937]  [wlan:ieee80211_sysctl_vattach+0x1b1/0x310] :wlan:ieee80211_sysctl_vattach+0x1b1/0x310
Apr 30 17:58:59 mr-turk kernel: [  138.566954]  [ath_pci:ieee80211_vap_setup+0x288/0x380] :wlan:ieee80211_vap_setup+0x288/0x380
Apr 30 17:58:59 mr-turk kernel: [  138.566979]  [ath_pci:ath_vap_create+0x139/0x710] :ath_pci:ath_vap_create+0x139/0x710
Apr 30 17:58:59 mr-turk kernel: [  138.567011]  [wlan:ieee80211_ioctl_create_vap+0xc4/0x100] :wlan:ieee80211_ioctl_create_vap+0xc4/0x100
Apr 30 17:58:59 mr-turk kernel: [  138.567020]  [__do_fault+0x1f5/0x430] __do_fault+0x1f5/0x430
Apr 30 17:58:59 mr-turk kernel: [  138.567045]  [ath_pci:ath_ioctl+0xc1/0x2e0] :ath_pci:ath_ioctl+0xc1/0x2e0
Apr 30 17:58:59 mr-turk kernel: [  138.567054]  [ipv6:__dev_get_by_name+0x8f/0x360] __dev_get_by_name+0x8f/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.567070]  [dev_ioctl+0x3f2/0x590] dev_ioctl+0x3f2/0x590
Apr 30 17:58:59 mr-turk kernel: [  138.567085]  [xt_hashlimit:kmem_cache_alloc+0x67/0xa0] kmem_cache_alloc+0x67/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.567097]  [sk_prot_alloc+0x51/0xe0] sk_prot_alloc+0x51/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.567117]  [sock_ioctl+0xed/0x260] sock_ioctl+0xed/0x260
Apr 30 17:58:59 mr-turk kernel: [  138.567129]  [do_ioctl+0x2f/0xa0] do_ioctl+0x2f/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.567137]  [vfs_ioctl+0x220/0x2c0] vfs_ioctl+0x220/0x2c0
Apr 30 17:58:59 mr-turk kernel: [  138.567141]  [xfs:fd_install+0x25/0x210] fd_install+0x25/0x60
Apr 30 17:58:59 mr-turk kernel: [  138.567153]  [sys_ioctl+0x91/0xb0] sys_ioctl+0x91/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.567168]  [system_call+0x7e/0x83] system_call+0x7e/0x83
Apr 30 17:58:59 mr-turk kernel: [  138.567198] 
Apr 30 17:58:59 mr-turk kernel: [  138.567204] sysctl table check failed: /net/ath0/monitor_crc_errors  Sysctl already exists
Apr 30 17:58:59 mr-turk kernel: [  138.567207] Pid: 9660, comm: wlanconfig Tainted: P        2.6.24-16-generic #1
Apr 30 17:58:59 mr-turk kernel: [  138.567209] 
Apr 30 17:58:59 mr-turk kernel: [  138.567209] Call Trace:
Apr 30 17:58:59 mr-turk kernel: [  138.567216]  [set_fail+0x4d/0x70] set_fail+0x4d/0x70
Apr 30 17:58:59 mr-turk kernel: [  138.567224]  [sysctl_check_table+0x2c5/0x620] sysctl_check_table+0x2c5/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.567229]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.567245]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.567250]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.567266]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.567286]  [xfs:register_sysctl_table+0x60/0xe0] register_sysctl_table+0x60/0xc0
Apr 30 17:58:59 mr-turk kernel: [  138.567304]  [wlan:ieee80211_sysctl_vattach+0x1b1/0x310] :wlan:ieee80211_sysctl_vattach+0x1b1/0x310
Apr 30 17:58:59 mr-turk kernel: [  138.567321]  [ath_pci:ieee80211_vap_setup+0x288/0x380] :wlan:ieee80211_vap_setup+0x288/0x380
Apr 30 17:58:59 mr-turk kernel: [  138.567346]  [ath_pci:ath_vap_create+0x139/0x710] :ath_pci:ath_vap_create+0x139/0x710
Apr 30 17:58:59 mr-turk kernel: [  138.567378]  [wlan:ieee80211_ioctl_create_vap+0xc4/0x100] :wlan:ieee80211_ioctl_create_vap+0xc4/0x100
Apr 30 17:58:59 mr-turk kernel: [  138.567390]  [__do_fault+0x1f5/0x430] __do_fault+0x1f5/0x430
Apr 30 17:58:59 mr-turk kernel: [  138.567415]  [ath_pci:ath_ioctl+0xc1/0x2e0] :ath_pci:ath_ioctl+0xc1/0x2e0
Apr 30 17:58:59 mr-turk kernel: [  138.567424]  [ipv6:__dev_get_by_name+0x8f/0x360] __dev_get_by_name+0x8f/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.567440]  [dev_ioctl+0x3f2/0x590] dev_ioctl+0x3f2/0x590
Apr 30 17:58:59 mr-turk kernel: [  138.567455]  [xt_hashlimit:kmem_cache_alloc+0x67/0xa0] kmem_cache_alloc+0x67/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.567468]  [sk_prot_alloc+0x51/0xe0] sk_prot_alloc+0x51/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.567487]  [sock_ioctl+0xed/0x260] sock_ioctl+0xed/0x260
Apr 30 17:58:59 mr-turk kernel: [  138.567499]  [do_ioctl+0x2f/0xa0] do_ioctl+0x2f/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.567507]  [vfs_ioctl+0x220/0x2c0] vfs_ioctl+0x220/0x2c0
Apr 30 17:58:59 mr-turk kernel: [  138.567511]  [xfs:fd_install+0x25/0x210] fd_install+0x25/0x60
Apr 30 17:58:59 mr-turk kernel: [  138.567523]  [sys_ioctl+0x91/0xb0] sys_ioctl+0x91/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.567539]  [system_call+0x7e/0x83] system_call+0x7e/0x83
Apr 30 17:58:59 mr-turk kernel: [  138.567568] 
Apr 30 17:58:59 mr-turk kernel: [  138.567574] sysctl table check failed: /net/ath0/%parent  Sysctl already exists
Apr 30 17:58:59 mr-turk kernel: [  138.567577] Pid: 9660, comm: wlanconfig Tainted: P        2.6.24-16-generic #1
Apr 30 17:58:59 mr-turk kernel: [  138.567579] 
Apr 30 17:58:59 mr-turk kernel: [  138.567579] Call Trace:
Apr 30 17:58:59 mr-turk kernel: [  138.567586]  [set_fail+0x4d/0x70] set_fail+0x4d/0x70
Apr 30 17:58:59 mr-turk kernel: [  138.567594]  [sysctl_check_table+0x2c5/0x620] sysctl_check_table+0x2c5/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.567599]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.567615]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.567620]  [sysctl_check_lookup+0xc6/0xe0] sysctl_check_lookup+0xc6/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.567636]  [sysctl_check_table+0x2db/0x620] sysctl_check_table+0x2db/0x620
Apr 30 17:58:59 mr-turk kernel: [  138.567656]  [xfs:register_sysctl_table+0x60/0xe0] register_sysctl_table+0x60/0xc0
Apr 30 17:58:59 mr-turk kernel: [  138.567673]  [wlan:ieee80211_sysctl_vattach+0x1b1/0x310] :wlan:ieee80211_sysctl_vattach+0x1b1/0x310
Apr 30 17:58:59 mr-turk kernel: [  138.567691]  [ath_pci:ieee80211_vap_setup+0x288/0x380] :wlan:ieee80211_vap_setup+0x288/0x380
Apr 30 17:58:59 mr-turk kernel: [  138.567716]  [ath_pci:ath_vap_create+0x139/0x710] :ath_pci:ath_vap_create+0x139/0x710
Apr 30 17:58:59 mr-turk kernel: [  138.567748]  [wlan:ieee80211_ioctl_create_vap+0xc4/0x100] :wlan:ieee80211_ioctl_create_vap+0xc4/0x100
Apr 30 17:58:59 mr-turk kernel: [  138.567757]  [__do_fault+0x1f5/0x430] __do_fault+0x1f5/0x430
Apr 30 17:58:59 mr-turk kernel: [  138.567781]  [ath_pci:ath_ioctl+0xc1/0x2e0] :ath_pci:ath_ioctl+0xc1/0x2e0
Apr 30 17:58:59 mr-turk kernel: [  138.567790]  [ipv6:__dev_get_by_name+0x8f/0x360] __dev_get_by_name+0x8f/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.567805]  [dev_ioctl+0x3f2/0x590] dev_ioctl+0x3f2/0x590
Apr 30 17:58:59 mr-turk kernel: [  138.567821]  [xt_hashlimit:kmem_cache_alloc+0x67/0xa0] kmem_cache_alloc+0x67/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.567834]  [sk_prot_alloc+0x51/0xe0] sk_prot_alloc+0x51/0xe0
Apr 30 17:58:59 mr-turk kernel: [  138.567853]  [sock_ioctl+0xed/0x260] sock_ioctl+0xed/0x260
Apr 30 17:58:59 mr-turk kernel: [  138.567881]  [do_ioctl+0x2f/0xa0] do_ioctl+0x2f/0xa0
Apr 30 17:58:59 mr-turk kernel: [  138.567889]  [vfs_ioctl+0x220/0x2c0] vfs_ioctl+0x220/0x2c0
Apr 30 17:58:59 mr-turk kernel: [  138.567893]  [xfs:fd_install+0x25/0x210] fd_install+0x25/0x60
Apr 30 17:58:59 mr-turk kernel: [  138.567905]  [sys_ioctl+0x91/0xb0] sys_ioctl+0x91/0xb0
Apr 30 17:58:59 mr-turk kernel: [  138.567921]  [system_call+0x7e/0x83] system_call+0x7e/0x83
Apr 30 17:58:59 mr-turk kernel: [  138.567950] 
Apr 30 17:58:59 mr-turk kernel: [  138.567951] ath0: failed to register sysctls!
Apr 30 17:58:59 mr-turk kernel: [  138.602630] ath0: unable to register device
Apr 30 17:58:59 mr-turk avahi-daemon[8574]: Joining mDNS multicast group on interface ath0.IPv4 with address 192.168.2.2.
Apr 30 17:58:59 mr-turk avahi-daemon[8574]: New relevant interface ath0.IPv4 for mDNS.
Apr 30 17:58:59 mr-turk avahi-daemon[8574]: Registering new address record for 192.168.2.2 on ath0.IPv4.

(in reply to: ↑ description ) 05/04/08 04:27:36 changed by m@tthew.ca

Further to my comment above (the really long one with lots of error log), I downloaded the 0.9.3.3 source, compiled it, and installed it this evening. My machine now works perfectly, behaving as a good AP should. Therefore, it appears that something broke between 0.9.3.3 and 0.9.4. Exactly what, I have no idea.

If requested by a madwifi developer, I can do a small amount of testing to see if a newer version works as advertised. However, until ubuntu pushes a kernel upgrade I'm going to remain on 0.9.3.3.

05/07/08 09:43:29 changed by Radek Stastny

IMHO it is not an Ubuntu problem. I have the same problem with Slackware 12.0, vanilla kernel 2.6.24.3.

05/07/08 09:48:18 changed by Radek Stastny

Well, I forgot. in my case system ends with kernel panic. Sometimes it is running for quite a long time (14 days) and sometimes it panics twice a day. Maybe some wrong packet can shut it down as problem is more frequent after I have added new client (quite far). I am using only MAC restrictions. no encryption at all.

05/08/08 18:08:33 changed by anonymous

I have the same problem too. My os is ubuntu 7.10, madwifi version 0.9.4, wireless card is D-link DWL-G650. After I create an AP and change channel, system freeze and Caps Lock light is flashing.

05/08/08 19:11:27 changed by anonymous

BTW, I also have tried madwifi 0.9.3.3 in Ubuntu 7.10, kernel 2.6.22.14, the problem is still there.

05/08/08 19:26:46 changed by Konstantin Zemlyak

Built SVN trunk on Fedora 8 x86_64:

# modinfo ath_pci
filename:       /lib/modules/2.6.24.5-85.fc8/net/ath_pci.ko
version:        svn r3620
...
# uname -a
Linux godai 2.6.24.5-85.fc8 #1 SMP Sat Apr 19 11:18:09 EDT 2008 x86_64 x86_64 x86_64 GNU/Linux

Seems to work fine so far.

(follow-up: ↓ 11 ) 05/10/08 09:03:18 changed by mentor

  • priority changed from critical to major.

(in reply to: ↑ 10 ) 05/26/08 19:11:43 changed by sjensen@versanet.de

Built SVN trunk on Fedora 8 i686:

filename:       /lib/modules/2.6.24.7-92.fc8/net/ath_pci.ko
license:        Dual BSD/GPL
version:        svn r3679
description:    Support for Atheros 802.11 wireless LAN cards.
author:         Errno Consulting, Sam Leffler
srcversion:     305431AF51E4B93BAEDC620

no freezes anymore, but when in ap mode the driver seems not to communicate. e.g.: hostapd starts up correctly but didn't receive any events from madwifi. (can't connect with/without wep/wpa or RSN)

(follow-up: ↓ 13 ) 05/30/08 17:57:39 changed by misc1@primarykey.ca

I have a simillar issue. I was getting a system lockup after invoking

iwconfig wlan0 essid "myessid" channel 6

This may have been due to an existing ath5k driver. I executed:

echo blacklist ath5k >> /etc/modprobe.d/blacklist
updatedb
rm -rf 'locate ath5k'
rmmod ath5k

and I no longer receive immediate freezes, but after 4 hours of operation and successful ethernet bridging through wlan0 the system froze again -- without reporting any errors.

I'm running:

uname -r
2.6.24.7-92.fc8
lspci | grep Atheros
00:08.0 Ethernet controller: Atheros Communications, Inc. AR5212 802.11abg NIC (rev 01)

(in reply to: ↑ 12 ; follow-up: ↓ 14 ) 05/30/08 18:11:00 changed by anonymous

Another note to add to my comments above: I currently have two client machines that connect to my Madwifi AP. One of the clients (Windows XP Home native client) has the wrong passphrase entered and continues to try and authenticate:


May 30 03:52:37 myhost hostapd: wlan0: STA 00:1c:df:57:83:58 IEEE 802.11: associated
May 30 03:52:40 myhost hostapd: wlan0: STA 00:1c:df:57:83:58 IEEE 802.11: deauthenticated due to local deauth request
May 30 03:52:40 myhost hostapd: wlan0: STA 00:1c:df:57:83:58 IEEE 802.11: disassociated
May 30 03:52:41 myhost hostapd: wlan0: STA 00:1c:df:57:83:58 IEEE 802.11: associated
May 30 03:52:44 myhost hostapd: wlan0: STA 00:1c:df:57:83:58 IEEE 802.11: deauthenticated due to local deauth request
May 30 03:52:44 myhost hostapd: wlan0: STA 00:1c:df:57:83:58 IEEE 802.11: disassociated

May 30 03:52:45 myhost hostapd: wlan0: STA 00:1c:df:57:83:58 IEEE 802.11: associated
May 30 09:00:36 myhost rsyslogd: [origin software="rsyslogd" swVersion="1.19.6" x-pid="1690"][x-configInfo udpReception="No" udpPort="514" tcpReception="No" tcpPort="0"] restart

May 30 09:00:36 myhost kernel: rklogd 1.19.6, log source = /proc/kmsg started.
May 30 09:00:36 myhost kernel: Initializing cgroup subsys cpuset
May 30 09:00:36 myhost kernel: Linux version 2.6.24.7-92.fc8 (mockbuild@xenbuilder4.fedora.phx.redhat.com) (gcc version 4.1.2 20070925 (Red Hat 4.1.2-33)) #1 SMP Wed May 7 16:50:09 EDT 2008
May 30 09:00:36 myhost kernel: BIOS-provided physical RAM map


Notice the crash at around 3:52 AM with no logged error. The continuous authentication attemps may have contributed to the crash.

Replying to misc1@primarykey.ca:

(in reply to: ↑ 13 ) 05/30/08 21:18:50 changed by misc1@primarykey.ca

One more note: I cold booted my machine at 9:00 as it was totally locked up and unresponsive to the keyboard.

Replying to anonymous:

07/31/08 18:51:50 changed by proski

  • priority changed from major to blocker.
  • status changed from new to assigned.
  • owner set to proski.
  • milestone set to version 0.9.4.1.

08/06/08 04:24:05 changed by proski

  • summary changed from Master Mode results in Kernel freeze to Channel switch on active interface in master mode causes hard lockup.

08/06/08 05:40:14 changed by proski

#1881 and #1889 have been marked as duplicates of this ticket. I know, it would be better to make new tickets duplicate, but this one got more attention and seems better suited for consolidating the efforts. #1889 has a stack trace, which may be useful.

08/06/08 13:11:32 changed by reztho

It happens to me too, but only when I make a second vap (without any sta or monitor defined before, just the first vap) and after two minutes or some more (10 minutes max) of using my computer. There are no traces in the logs to give them to you. I'm using arch linux with the regular stock kernel and the regular compiled madwifi driver from them.

08/12/08 07:08:21 changed by info@pc-tiede.de

I can confirm this for my AMD64 system. Loading of modules does nothing, but setting up a VAP freezes the system after a few seconds. It works well with drivers from trunk/.

(in reply to: ↑ description ) 08/25/08 01:50:33 changed by britabroad321@yahoo.com

i too was experiencing this issue. Upon upgrading to lasted trunk release from SVN, the problem appears to be resolved. I can switch channel after creating the AP using wlanconfig. However, even though iwconfig reports the AP interface is using the channel requested, when I bring up netstumber on another machine, it reports that the access point is scrolling through all channels, eg channel hopping. using athchns to try to combat this results in the system lockup scenario coming back.

Also worthy of note, when wlanconfig created ath0 and confirms ath0 creation, udev moves that device to ath1 immediately (per dmesg). Im not sure why (Ubuntu 8.04), as that doesnt seem to happen when ath0 is in sta mode.

Now my AP appears running on ath1, but channel hopping. I try to create station and get the old "I/O error" which I used to get when not supplying "nosbeacon", however in the current driver "nosbeacon" is depreciated, so im not sure why I get "I/o error"

(follow-up: ↓ 22 ) 08/27/08 15:23:06 changed by proski

  • pending changed.

The code is trying to take the same lock twice. First, ieee80211_beacon_update() calls IEEE80211_LOCK(ic), and then ieee80211_free_node() calls IEEE80211_LOCK_IRQ(ic). The trunk doesn't lock ic in ieee80211_free_node(), but the differences in locking are significant, and I'm not sure they can be backported easily.

(in reply to: ↑ 21 ) 12/04/08 07:57:10 changed by anonymous

Replying to proski:

The code is trying to take the same lock twice. First, ieee80211_beacon_update() calls IEEE80211_LOCK(ic), and then ieee80211_free_node() calls IEEE80211_LOCK_IRQ(ic). The trunk doesn't lock ic in ieee80211_free_node(), but the differences in locking are significant, and I'm not sure they can be backported easily.

proski is there any update to this bug? As you can see here: bugs.launchpad.net/ubuntu/+source/linux-restricted-modules/+bug/276445 there are still more people having problems.

Thanks Thomas

12/06/08 07:25:47 changed by misc1@primarykey.ca

Hi There,

Yes, I was wondering the same thing: is there a roadmap for this item? It's the only issue with the Madwifi package that I'd consider to be an outlier.

Thanks -JASON

(follow-up: ↓ 25 ) 12/09/08 18:42:14 changed by proski

There is no roadmap. No patches have been suggested. No help was offered by anyone who fixed this issue in the trunk.

(in reply to: ↑ 24 ) 12/11/08 22:12:05 changed by anonymous

Replying to proski:

There is no roadmap. No patches have been suggested. No help was offered by anyone who fixed this issue in the trunk.

I'd like to help you, but I have lesser than none experience in driver programming :(

01/21/09 22:25:25 changed by tsharples

We have seen the same problem here using 9.3.3, especially when switching from a turbo to a non-turbo channel. Best solution seems to be rigorously observing the following sequence:

ifconfig wlan0 down
sleep 1
iwconfig wlan0 channel 0
sleep 1
iwconfig wlan0 channel <the desired channel>
sleep 1
ifconfig wlan0 up

Enclose a pair of the above (with different channels) in a while [ 1 ] loop, and go have lunch, to test for crashes on your target system.

03/25/09 05:28:05 changed by proski

The fundamental problem lies in net80211/ieee80211_node.c:

        /*
         * XXX: may need to lock out the following race. we dectestref
         *      and determine it's time to free the node. between the if()
         *      and lock, we take an rx intr to receive a frame from this
         *      node. the rx path (tasklet or intr) bumps this node's
         *      refcnt and xmits a response frame. eventually that response
         *      will get reaped, and the reaping code will attempt to use
         *      the node. the code below will delete the node prior
         *      to the reap and we could get a crash.
         *
         *      as a stopgap before delving deeper, lock intrs to
         *      prevent this case.
         */
        IEEE80211_LOCK_IRQ(ic);

IEEE80211_LOCK_IRQ is spin_lock_irqsave(). It doesn't lock all interrupts on SMP systems. It only locks interrupts on the current CPU. Other CPUs will still run. If any of them needs to acquire that spinlock, the CPU will stop and wait. spin_lock_irqsave() is a wrong function for the job it's supposed to do.

05/04/09 00:08:33 changed by series8217@hotmail.com

How's the fix coming along?

I'm experiencing this with a 3COM Wifi Card that uses the Atheros chipset. I bought it specifically because of some decent linux reviews... but many times it hard locks my system while connecting to my access point or after a couple hours of internet use. Not fun.

05/04/09 06:23:17 changed by misc1@primarykey.ca

You might want to try ath9k: it works with hostapd in master mode quite well (it appears that development focus has shifted to this build).

05/07/09 06:39:47 changed by series8217@hotmail.com

I did try loading ath9k but apparently my card is not supported (802.11/a/b/g not n...). It's a 3COM 3CRDAG675B with the Atheros 5414 chipset..

12/12/09 21:38:22 changed by news@knapek.pl

Same problem on Slackware 13.0 with original 2.6.29.6-smp (though only 1 CPU/core inside).

System running as home wireless router. Wireless device is Planet WL-8310.

madwifi 0.9.4 + hostapd 0.6.9

It runs stable as long as there is only one client (usually Monday-Friday without a crash). Every weekend, when I bring 2nd laptop home, the system starts to freeze-dead randomly. Nothing in the logs.

I will try to switch to the ath5k driver.